# Class RANS4x8Decode

java.lang.Object
htsjdk.samtools.cram.compression.rans.RANSDecode
htsjdk.samtools.cram.compression.rans.RANS4x8Decode

public class RANS4x8Decode extends RANSDecode
Decoder for the CRAM 3.0 rANS 4x8 codec. Supports Order-0 and Order-1 decoding with 4-way interleaved rANS states. Each state processes one quarter of the output, enabling instruction-level parallelism.

## Constructor Summary

Constructors
Constructor
Description
`RANS4x8Decode()`

## Method Summary

Modifier and Type
Method
Description
`byte[]`
`uncompress(byte[] input)`
Uncompress a rANS 4x8 encoded byte stream.

### Methods inherited from class RANSDecode

`getDecodingSymbols, getFrequencies, getReverseLookup, markRowUsed, resetDecoderState`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### RANS4x8Decode

public RANS4x8Decode()

## Method Details

### uncompress

public byte[] uncompress(byte[] input)
Uncompress a rANS 4x8 encoded byte stream. The first byte of the input indicates the order (0 or 1), followed by compressed and uncompressed lengths, the frequency table, and the encoded data.

Specified by:
  `uncompress` in class `RANSDecode`
Parameters:
  `input` - the compressed byte stream
Returns:
  the uncompressed data